//
//  Collection.h
//  CoreData
//
//  Created by Conor Dearden on 16/3/07.
//  Copyright 2007 Chiguire LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface MOCollection : NSManagedObject {
	//NSArray *nameAndImage;
	NSProgressIndicator *spinningIndicator;
	//NSMutableDictionary *extraDataDict;
}

@property (nonatomic, retain) NSProgressIndicator *spinningIndicator;
@property (nonatomic, readonly) NSString *name;
@property (nonatomic, readonly) NSImage *sourceIcon;
@property (nonatomic) NSUInteger coverViewCellSize;
//@property (nonatomic, assign) NSIndexSet *selectionIndexes;

- (NSIndexSet *)selectionIndexes;
- (void)saveSelectionIndex;
- (void)setSelectionIndexForEntries:(NSArray *)someEntries;

- (BOOL)isDescendantOfNode:(NSManagedObject *)node;
- (NSMutableArray *)sortDescriptorsArray;
- (void)setSortDescriptorsArray:(NSMutableArray *)sortDescriptors;
- (NSArray *)columnsArray;
- (void)setColumnsArray:(NSArray *)someColumns;
- (NSPredicate *)smartPredicate;
- (NSPredicate *)smartPredicateWithSubstitution;
- (void)setSmartPredicate:(NSPredicate *)aPredicate;

- (BOOL)isSmartCollection;
- (BOOL)isSharedCollection;
- (BOOL)isGroupCollection;
- (BOOL)isDoghouseCollection;


- (void)fetchSmartEntries;
- (void)updateSmartCollections;

- (BOOL)isExcluded;

- (NSSet *)entries;
- (NSMutableSet *)allEntriesUIDs;
//- (NSArray *)nameAndImage;
//- (void)reloadNameAndImage;

- (NSMutableDictionary *)extraDataDictionary;
- (void)setExtraDataDictionary:(NSMutableDictionary *)someDictionary;
- (void)setObject:(id)anObject forExtraDataDictionaryKey:(NSString *)aKey;

- (void)startSpinningIndicator;
- (void)stopSpinningIndicator;
- (void)updateLocationOfSpinningIndicatorToRow:(NSInteger)aRow;

// Threading for MyDataOperation
- (void)deleteEntries:(NSSet *)someEntries withContext:(NSManagedObjectContext *)context;
- (void)insertWithAttributtes:(NSDictionary *)aDictionary withContext:(NSManagedObjectContext *)context;
@end

@interface MOCollection (EntriesAccessors)

- (void)addEntriesObject:(MOEntry *)anEntry;
- (void)removeEntriesObject:(MOEntry *)anEntry;
//- (void)addEntries:(NSSet *)value;
//- (void)removeEntries:(NSSet *)value;

@end



