//  MyControllerShared.h

#import <Cocoa/Cocoa.h>

#define registerWithKey HTDYEIEIEME

@class MyWarningSheet, MyAboutPanel, MyTableView, MyCollectionTableView, MyCoverView, MyWebView, MyMainCoverImageView, MyComboBoxDataShared, MyEditViewMulti, MyMoreDrawer, MyLlave, MyFieldsControllerShared, MyToolbar, MySmartCollection, MyImport, MyAddMultiple, MyInternetSearchPanel, MyExport, MyPluginManager, MyLinksManager, MyAddressBook, MyFullScreenWindow, MyPrint, MyIncrementalID, MOCollection, MyCreditsData, MyPanel, SUUpdater, MyViewOptionsWindow, JBMailer, MyBluetoothScanner, MyCoverFlowView, MyCoverFlow, MyiPhoneSync, MyImageCapture, MyDoghouse, MyPediaPlugin, MyPreferencesShared, MyAnimatingTextField;

enum {
	MKSelectionNone = 0,
	MKSelectionMultiple,
	MKSelectionMultipleCounted
}; typedef NSInteger MKSelectionCount;

enum {
	MKDuplicatesNone = 0,
	MKDuplicatesSkip = 1,
	MKDuplicatesAdd,
}; //typedef NSInteger MKDuplicates;

enum {
	MKStatusTypeNone = 0,
	MKStatusTypeBorrowed,
	MKStatusTypeOverdue,
	MKStatusTypeComingSoon	
};
//typedef NSInteger MKStatusType;

enum {
    MKShowingNone = 0,
    MKShowingDuplicates,
    MKShowingFiltered,
    MKShowingStats
};


@interface MyControllerShared : NSObject <HIDRemoteDelegate, NSApplicationDelegate> {
	
	//Views
	IBOutlet MyTableView *mainTableView;
	IBOutlet MyCollectionTableView *collections;
	IBOutlet MyMainCoverImageView *mainCoverImageView;
	IBOutlet MyWebView *webView;
	IBOutlet NSTabView *theTabView;
	IBOutlet NSSplitView *mainSplitView;

	IBOutlet MyAnimatingTextField *busyIndicatorMessage;
	IBOutlet NSTextField *bottomInfoTextField;
	IBOutlet NSMenuItem *infoMenuItem;
	IBOutlet MyViewOptionsWindow *viewOptionsWindow;
	
	IBOutlet MyCoverFlowView *coverFlowView;
	MyCoverFlow *coverFlow;
	
	//Objects
	IBOutlet MyComboBoxDataShared *comboBoxData;
	IBOutlet MyMoreDrawer *theMoreResults;
	IBOutlet MyToolbar *theToolbar;
	IBOutlet MyPluginManager *pluginManager;
	IBOutlet MyInternetSearchPanel *internetSearchPanel;
	IBOutlet MyAddressBook *addressBook;

	MyPreferencesShared *preferencesController;
	
	JBMailer *mailer;
	MyiPhoneSync *iPhoneSync;

	//ADD Panel
	IBOutlet MyPanel *addPanel;
	IBOutlet MyCoverView *coverView;
	IBOutlet NSProgressIndicator *theBusyAnimationAdd;
	IBOutlet NSTextField *happeningTextField;
	IBOutlet NSButton *addButtonPanel;
    IBOutlet NSButton *nextButtonPanel;
    IBOutlet NSButton *backButtonPanel;
    IBOutlet NSButton *cancelButton;
    IBOutlet NSButton *newButton;
	IBOutlet NSButton *moreDrawerButton;
	//IBOutlet NSTabView *addPanelTabView;  //### Could be replaced by calling the getter methods on the add panel
	IBOutlet MyLinksManager *linksManager;	

	//MyRemoteControl *controlRemote;
	IBOutlet NSSearchField *searchField; //### Should make it an accessor method, fine as is for speed reasons

	
	//tab view related
	IBOutlet NSSlider *sizeSlider;
	IBOutlet NSImageView *bigImage;
	IBOutlet NSImageView *smallImage;
	//IBOutlet NSButton *coverViewButton;
	//IBOutlet NSButton *tableViewButton;
	//IBOutlet NSButton *coverflowViewButton;
	IBOutlet NSMenuItem *coverViewMenu;
	IBOutlet NSMenuItem *tableViewMenu;
	IBOutlet NSMenuItem *coverFlowMenu;
	
	//IBOutlet NSMenuItem *pocketpediaMenu;

	//progress panel	
	
	//External Nibs
	IBOutlet MyImport *importTabComaObject;
	IBOutlet MyAddMultiple *multiAddInstance;
	IBOutlet MyEditViewMulti *multiEditView;
	IBOutlet MyPrint *printInstance;
	IBOutlet MyIncrementalID *incrementalID;
	

	//Controllers
	IBOutlet NSArrayController *entriesController;

	//Core Data
	NSPersistentStoreCoordinator *persistentStoreCoordinator;
    NSManagedObjectModel *managedObjectModel;
    NSManagedObjectContext *managedObjectContext;
	NSManagedObject *idGenerator;
	
	MyFieldsControllerShared *fieldsController;
	MyImageCapture *imageCapture;
	
	id searchInProgress;
	MyPediaPlugin *searchSite;

	NSUserDefaults *preferencesStandard;
	
	
	NSUInteger tabViewSelected;
    MKFilter previousSearchType;
	NSInteger totalResults, currentAddPanelResultNumber;
	MKProgramType programType;
	NSInteger skipDuplicates;
	BOOL editingExistingValue, holdDisplayUpdate, dontRevealMore, advanceGettingInfo, searchOnGoingPlugin, displaySimiliarProducts, displayLinks; //spotlight
    BOOL preserveSelection;
	BOOL encodeUTF8Characters;
	BOOL controlRemoteLoaded;
	short showingMode;
    BOOL doNotAddLinks;
    BOOL spotlightTurnOff;
    BOOL duplicatesUPCMatch;
    BOOL foreignArticleCompare;
#ifndef MacAppStore
	BOOL blocked;
#endif //MacAppStore
	MKSelectionCount multipleSelection;

	NSArray *bottomFields, *positionSortDescriptors, *nameSortDescriptors, *dateSortDescriptors; 
	//NSArray *doNotDisplayInDetailsView;
	NSMutableArray *entriesNotFound, *coverUIDsToDelete;
	NSString *dataFolderPath, *advancedSearchSite, *tempDirectoryForApp; //, *metaDataFolderPath;
	//NSString *extensionMetaDataFile;
	
	//NSMutableData *receivedData; //For the automatic version check
	//NSEnumerator *advancedRows;
	//NSMutableIndexSet *advanceSelectedIndexes;
	NSMutableArray *advanceEntriesToUpdate;
	NSBundle *frameworkBundle;
	
	NSArray *previousSelection;
	
	NSEntityDescription *programEntryEntity;   
	MyBluetoothScanner *bluetoothScanner;

	NSMutableString *windowFooterString;
	
	//NSString *regularDateFormat, *releaseDateFormat, *theatricalDateFormat;
	NSDateFormatter *exportDateFormatter, *regularDateFormatter, *theatricalDateFormatter, *releaseDateFormatter;
	
	IBOutlet MyWarningSheet *warningSheet;
    NSString *clickedField;

@private
    BOOL doneLaunchingOrTerminating;

	IBOutlet MyAboutPanel *aboutPanel; 
	IBOutlet MySmartCollection *smartCollectionInstance;
	
	IBOutlet MyExport *exportInstance;
	
	IBOutlet NSPanel *borrowedHistoryPanel, *lastUsedPanel;
	
	MyFullScreenWindow *fullScreenWindow;

    // If toolbar not displayed then, button can be nil
    NSSegmentedControl *selectedViewButton;
}

//@property (nonatomic, retain) NSDateFormatter *regularDateFormatter;
//@property (nonatomic, retain) NSDateFormatter *releaseDateFormatter;
//@property (nonatomic, retain) NSDateFormatter *theatricalDateFormatter;
@property (nonatomic, retain) NSDateFormatter *exportDateFormatter;
@property (nonatomic, readonly) MyPreferencesShared *preferencesController;
@property (readonly) MyAnimatingTextField *busyIndicatorMessage;
@property (assign) BOOL doNotAddLinks;
@property (assign) BOOL preserveSelection;
@property (readonly) MyiPhoneSync *iPhoneSync;
@property (retain) NSSegmentedControl *selectedViewButton;
@property (assign, nonatomic) NSInteger totalResults;
@property (assign, nonatomic) BOOL foreignArticleCompare;
@property (retain, nonatomic) NSString *clickedField;

// Hold on to NIBs
@property (strong, nonatomic) NSArray *importPanelTopLevelObjects;
@property (strong, nonatomic) NSArray *multiEditTopLevelObjects;
@property (strong, nonatomic) NSArray *incrementalTopLevelObjects;
@property (strong, nonatomic) NSArray *borrowedHistoryTopLevelObjects;
@property (strong, nonatomic) NSArray *exportTopLevelObjects;
@property (strong, nonatomic) NSArray *warningTopLevelObjects;
@property (strong, nonatomic) NSArray *aboutTopLevelObjects;
@property (strong, nonatomic) NSArray *smartCollectionTopLevelObjects;
@property (strong, nonatomic) NSArray *printTopLevelObjects;
@property (strong, nonatomic) NSArray *multiAddTopLevelObjects;
@property (strong, nonatomic) NSArray *preferencesTopLevelObjects;

+ (NSString *)programName;
+ (MyControllerShared *)controller;
+ (SInt32)osVersion;


- (NSString *)applicationSupportFolder;
- (NSString *)dataFolderPath;
- (NSString *)dataFilePath;
//- (NSString *)metaDataFolderPath;

- (BOOL)saveManagedObjectContext;
- (void)performCheckpointInSQLite;


- (NSPersistentStoreCoordinator *)persistentStoreCoordinator;
- (id)objectForPersistantStoreKey:(NSString *)aKey;
- (void)setObject:(id)anObject forPersistantStoreKey:(NSString *)aKey;

- (NSManagedObjectModel *)managedObjectModel;
- (NSManagedObjectContext *)managedObjectContext;
- (NSString *)localCoreDataID;
- (NSArray *)fetchEntriesWithPredicate:(NSPredicate *)aPredicate;
- (void)deleteUID:(NSNumber *)uid;


//- (IBAction)saveAction:sender;
- (NSArrayController *)entriesController;
- (NSArray *)collectionsSortDescriptor;
- (NSArray *)positionSortDescriptors;
- (NSArray *)nameSortDescriptors;
- (NSArray *)dateSortDescriptors;

- (NSArray *)entriesForUIDs:(NSArray *)anArray;
- (NSEntityDescription *)programEntryEntity;
		
- (void)refreshCollectionFromManagedObject:(MOCollection *)aCollection;


#pragma mark Database
- (void)selectDatabase;
- (void)clearFetchedInstances;
//- (IBAction)cleanDatabase:(id)sender;
- (BOOL)loadDatabaseAt:(NSString *)aDatabasePath;


#pragma mark Table
- (void)deselectAllRows;
- (void)higlightRowWithCharacters:(NSString *)stringToSearch;
- (void)selectRowIndexes:(NSIndexSet *)anIndexSet byExtendingSelection:(BOOL)flag;

- (BOOL)findEntry:(NSDictionary *)entryDictionary;
- (void)selectEntry:(NSManagedObject *)anEntry;


#pragma mark Display
- (void)changeEntry;
- (BOOL)willChangeCollectionTo:(MOCollection *)aCollection;
- (void)changeCollection;
- (void)refreshInformation;
- (void)setCoverImageViewNeedsDisplay;
- (void)updateCovers;
- (void)resetAddPanel;
- (IBAction)closeAddPanel:(id)sender;
- (void)showAddPanel;
- (IBAction)addPanelManualAdd:(id)sender;
- (void)setAddPanelForManualAdd;
- (IBAction)newSearch:(id)sender;

- (void)setSearchField:(NSSearchField *)field;
- (NSSearchField *)searchField;
- (void)filterBy:(NSString *)searchString onField:(NSString *)identifier;
- (void)search:(NSString *)searchString reload:(BOOL)reload; 

//- (void)sortCollection:(NSMutableDictionary *)aCollection by:(NSString *)sortBy;
//- (void)sortCollection:(NSMutableDictionary *)aCollection;
- (NSArray *)sortDescriptors;
- (void)addSortDescriptor:(NSSortDescriptor *)aSortDescriptor;
- (void)setEntriesControllerBindingBackToNormal;


#pragma mark Advance/Download/Plugin

- (void)resultsFoundWithSite:(id)nextSearchSite numberOfResults:(int)numberOfResults;
- (int)currentAddPanelResultNumber;
- (IBAction)nextResult:(id)sender;
- (void)chooseResult:(int)aNumber;
- (NSInteger)totalResults;
- (NSArray *)resultsTitles;
//- (void)downloadDVDs:(NSArray *)searchStringArray;
- (void)searchReturnedNumberOfResults:(NSInteger)numberOfResults sender:(id)sender;
//- (BOOL)advanceSearchBeingPerformed;
- (void)selectPluginResults:(int)row;
//- (void)executePlugin:(id)plugin;


#pragma mark Entry Getter Methods
- (NSArrayController *)entriesController;
- (NSArray *)arrangedEntries;
- (NSArray *)selectedEntries;
- (MOEntry *)selectedEntry;
- (NSString *)selectedEntryTitle;
- (NSArray *)allEntries;


#pragma mark Entry Setter Methods
- (NSNumber *)nextUID;
- (NSNumber *)nextSharedUIDWithContext:(NSManagedObjectContext *)context;
- (MOEntry *)duplicateEntry:(MOEntry *)nextEntry;
- (void)addEntriesWithAttributes:(NSArray *)entries;

- (BOOL)addEntry:(MOEntry *)anEntry toCollection:(MOCollection *)aCollection;
- (BOOL)addEntries:(NSArray *)someEntries toCollection:(MOCollection *)aCollection;
- (BOOL)addEntriesWithSpecialHandling:(NSArray *)someEntries toCollection:(MOCollection *)aCollection;

- (void)removeEntry:(MOEntry *)anEntry fromCollection:(MOCollection *)aCollection;
- (void)removeEntries:(NSArray *)someEntries fromCollection:(MOCollection *)aCollection;
- (void)removeEntriesFromAllCollections:(NSArray *)someEntries;
- (void)removeStatus:(NSArray *)someEntries;



- (IBAction)deleteSelected:(id)sender; //IBAction for toolbar menu item
- (void)deleteSelectedAllWarn:(BOOL)warn;

//- (void)sortCurrentCollection;
- (IBAction)removeCoverImage:(id)sender;
- (BOOL)writeOutCover:(NSImage *)aCover;

- (NSString *)cardExtension;
- (void)openCardAtPath:(NSString *)aPath;



#pragma mark Getters

- (NSButton *)moreDrawerButton;
- (NSString *)temporaryDirectory;
- (MyViewOptionsWindow *)viewOptionsWindow;
- (BOOL)isRetina;
- (MyPanel *)addPanel;
- (MyCollectionTableView *)getCollections;

- (MyComboBoxDataShared *)getComboBoxData;
- (MyTableView *)tableView;
- (MyWebView *)webView;
- (NSUInteger)tabViewSelected;
- (MyCoverView *)coverView;
- (MyCoverFlow *)coverFlow;
//- (BOOL)sortDescending;
- (NSString *)sortedColumnIdentifier:(NSString **)realColumn;
- (NSString *)sortedColumnIdentifierForDescriptors:(NSArray *)sortDescriptors realSortColumn:(NSString **)realColumn lastNameSort:(BOOL *)sortLastName;

//- (NSString *)sortedColumn;

- (BOOL)editingExisting;
- (MyFieldsControllerShared *)fieldsController;
- (MyInternetSearchPanel *)internetSearchPanel;

- (MKProgramType)programType;
- (MyLinksManager *)linksManager;
- (MyAddressBook *)addressBook;
- (MyPluginManager *)pluginManager;
- (NSMenuItem *)infoMenuItem;
- (NSString *)windowFooterString;
- (NSTextField *)bottomInfoTextField;
//- (BOOL)spotlight;
- (MyEditViewMulti *)multiEditView;

#pragma mark Setters
- (void)saveCurrentColumns;

//- (void)setImageUpdated:(BOOL)updated;
- (void)setTabViewSelected:(NSUInteger)newValue;
- (void)setMyRating:(NSInteger)starClicked;
- (void)setMyRatingRaw:(NSInteger)ratingRaw;
//- (BOOL)setSortDescendingValue:(BOOL)value;
- (void)setShowingMode:(NSInteger)anInteger;


#ifndef MacAppStore
- (NSString *)registrationKey;
- (void)registerWithKey:(NSString *)aString;
- (IBAction)registerApplication:(id)sender;
- (MyLlave *)initialisedLlaveObject;
- (IBAction)checkForUpdate:(id)sender;
//- (IBAction)installWidget:(id)sender;
#endif //MacAppStore

- (NSMutableArray *)entries:(NSArray *)someEntries inAnotherCollectionOtherThen:(NSManagedObject *)aCollection;

#pragma mark Subclassed
- (void)addNewEntry:(MOEntry *)anEntry toCollection:(MOCollection *)aCollection;
- (BOOL)addEntryFromAddPanelCheckForDuplicates:(BOOL)checkDuplicates;
- (IBAction)processAddPanel:(id)sender;
//- (void)createMetaDataFile:(MOEntry *)anEntry;
- (BOOL)openFile:(NSString *)filename;
- (BOOL)importTabCommaFile:(NSString *)filename;
- (BOOL)openDirectory:(NSString *)aDirectory;
- (IBAction)showContextualMenu:(id)sender;
- (IBAction)getPluginsInfo:(id)sender;
- (NSArray *)commonAttributesForNamingNewCollection;
- (NSDictionary *)collectionTotalsDictionaryFor:(NSArray *)arrangedObjects footer:(BOOL)forFooter;
- (void)refreshCollectionStatistics;
- (void)setNumberOfSelectedInFooter;
- (IBAction)editEntry:(id)sender;
- (void)multipleEditDone;
- (void)writeOutEdit:(MOEntry *)anEntry;
- (void)clearAddPanel;
- (NSString *)createStatisticsExport:(BOOL)forExport;
- (void)configureStats:(id)sender;
- (void)processNewLink:(NSMutableDictionary *)newLink;
- (BOOL)handleIncomingString:(NSString *)aString;

- (NSDictionary *)createLinksForEntries:(NSArray *)entriesNumber;
- (NSMutableString *)HTMLStringForEntries:(NSArray *)entriesNumber;
- (NSMutableString *)HTMLBibliographyForEntries:(NSArray *)someEntries;
- (NSMutableString *)stringBibliographyForEntries:(NSArray *)someEntries addFormat:(BOOL)addFormat;
//- (NSMutableString *)HTMLiWebSourceForEntries:(NSArray *)entriesNumber;
- (void)loadPreferenceValuesIncludingDates:(BOOL)datesAndColumns;
- (void)addValuesToAutofillForEntry:(NSManagedObject *)anEntry;
- (void)replaceKeysInTemplate:(NSMutableString *)workingRepeat forEntry:(MOEntry *)anEntry html:(BOOL)htmlOutput webView:(BOOL)forWebView;

- (NSString *)labelForSearchType:(NSNumber *)aNumber;
- (NSString *)searchIdentifierForSearchType:(NSInteger)searchType;
- (IBAction)printCollection:(id)sender;
- (IBAction)printCollectionSelection:(id)sender;

#pragma mark IBAction
- (IBAction)emptyAction:(id)sender;

- (IBAction)changeDatabase:(id)sender;

- (IBAction)tableViewDoubleAction:(id)sender;
- (IBAction)returnedClicked:(id)sender;
- (IBAction)changeTabView:(id)sender;
- (IBAction)openAddMultipleEntries:(id)sender;
- (IBAction)exportCollection:(id)sender;
- (IBAction)exportToIpod:(id)sender;
- (IBAction)exportToFTP:(id)sender;

- (IBAction)dismissFilterFooter:(id)sender;

//- (IBAction)openAmazon:(id)sender;
//- (IBAction)buyAtAmazon:(id)sender;
//- (IBAction)sellAtAmazon:(id)sender;
//- (IBAction)sellersAtAmazon:(id)sender;



- (IBAction)createSpotlightFiles:(id)sender;
- (IBAction)resetViewSizeToDefault:(id)sender;
- (IBAction)showMainWindow:(id)sender;

- (IBAction)captureImage:(id)sender;
- (void)setCapturedImage:(NSImage *)anImage;
- (void)releaseImageCapture;	
- (IBAction)makeColumnsDefault:(id)sender;
- (IBAction)selectRandomEntry:(id)sender;
- (IBAction)playFirstMovieLink:(id)sender;
- (IBAction)toogleFullScreenViewing:(id)sender;

- (IBAction)sendToiWeb:(id)sender;
- (IBAction)openHelp:(id)sender;
- (IBAction)openAboutPanel:(id)sender;
- (IBAction)opemIncrementalIDWindow:(id)sender;
- (IBAction)showDuplicates:(id)sender;

- (IBAction)showBorrowedHistory:(id)sender;
- (IBAction)showLastUsed:(id)sender;

- (IBAction)connectToBluetooth:(id)sender;
- (IBAction)openURL:(id)sender;
- (IBAction)openPreferences:(id)sender;
- (IBAction)markAs:(id)sender;


#pragma mark Borrowed
- (void)setBorrowedHistory:(MOEntry *)anEntry;
- (void)setBorrowed:(MOEntry *)anEntry name:(NSString *)name date:(NSDate *)date due:(NSDate *)dueDate uniqueID:(NSString *)uniqueID last:(BOOL)lastEntry;
- (void)addAllBorrowedEntriesToMailer;
- (IBAction)showMailerMessages:(id)sender;

#pragma mark Shared Instances
- (JBMailer *)sharedMailer;
- (MyExport *)exportInstance;
- (MyWarningSheet *)sharedWarningSheet;
- (IBAction)clearWarningMask:(id)sender;
- (MyAboutPanel *)sharedAboutPanel;
- (MySmartCollection *)sharedSmartCollection;
- (MyPrint *)sharedPrint;
- (MyAddMultiple *)sharedMultiAddInstance;
@property (nonatomic,readonly) MyAddMultiple *multiAddInstance;
- (MyBluetoothScanner *)sharedBluetoothScanner;


#pragma mark Other
- (void)setEncodeUTF8Characters:(BOOL)aBool;
- (NSMutableString *)encodeForHTML:(NSString *)aString;
- (NSMutableString *)normalizeLinkedFiledPath:(NSString *)aPath;
- (NSMutableString *)correctVolumesPath:(NSMutableString *)fixedPathOfFile;


- (void)installPediaExtras:(NSString *)filename;
- (void)exportCard:(NSString *)filePath;
- (void)openMovieAtPath:(NSString *)aPath;
- (IBAction)stopModalWithZero:(id)sender; //OK
- (IBAction)stopModalWithOne:(id)sender; //CANCEL
- (MOEntry *)entryWithLink:(NSString *)aURL;

- (BOOL)importDuplicates;

- (void)fillInformationFromCD;

#pragma mark Helpers
- (NSDateFormatter *)dateFormatterForField:(NSString *)anIdentifier;
- (NSString *)stringFromDate:(NSDate *)aDate identifier:(NSString *)fieldIdentifier;

- (void)setNextUIDToHighest;

@end


