/* MyPrint */

#import <Cocoa/Cocoa.h>

@interface MyPrint : NSObject
{	
	IBOutlet NSTabView *styleTabView;
	
	//List
	IBOutlet NSPopUpButton *borderStylePopUp;
	IBOutlet NSPopUpButton *columnsPopUp;
	IBOutlet NSImageView *previewImageView;
	IBOutlet NSButton *headerCheckBox;
	IBOutlet NSButton *statusCheckBox;
	IBOutlet NSButton *horizontalLinesCheckBox;
	IBOutlet NSColorWell *lineColorWell;
	IBOutlet NSSlider *rowHeightSlider;

	
	//Cover
	IBOutlet NSTextField *heightDisplay;
	IBOutlet NSTextField *widthDisplay;
	IBOutlet NSTextField *coverSpacingField;
	IBOutlet NSButton *dontDistortCheckBox;
	IBOutlet NSButton *fillCoverCheckBox;
	
	IBOutlet NSTextField *descriptionField;
	IBOutlet NSTextField *coverDescriptionField;
	
	// Templates
	IBOutlet NSPopUpButton *templatesPopUp;
	IBOutlet NSProgressIndicator *exportingProgressIndicator;
	IBOutlet NSTextField *templateDescription;

	
	NSWindow *windowHoldingView;  //Need a window to create the preview
	
	NSArray *columnOptions;
	NSPrintOperation *printOperation;
	float coverRatio;
	NSView *currentPrintView;
	BOOL userChangedLandscapeMode;
	
	//double horizontalDPI, verticalDPI;
	
}
- (void)printDialog;
- (IBAction)print:(id)sender;
- (IBAction)closePrintDialog:(id)sender;

- (IBAction)showPageSetup:(id)sender;

- (void)displayPreviewFor:(NSView *)aView;

//Delegate from Tab view
- (void)tabView:(NSTabView *)tabView didSelectTabViewItem:(NSTabViewItem *)tabViewItem;

//Setters
- (void)setCoverRatio:(float)aRatio;
- (void)setListColumns:(NSArray *)aColumnInfo;

//Getter
- (NSTextField *)coverDescriptionField;
- (NSImageView *)previewImageView;

//Set Lists 
- (IBAction)hasHeader:(id)sender;
- (IBAction)setBorder:(id)sender;
- (IBAction)setLineColor:(id)sender;
- (IBAction)showHorizontalLines:(id)sender;
- (IBAction)showStatusBar:(id)sender;
- (IBAction)changeColumns:(id)sender;
- (IBAction)setRowHeight:(id)sender;

//Set Cover
- (IBAction)setCoverSize:(id)sender;
- (IBAction)setCoverFill:(id)sender;
- (IBAction)setCoverSpacing:(id)sender;
- (IBAction)dontDistort:(id)sender;

// Set templates
- (IBAction)setTemplateChanging:(id)sender;
- (NSTextField *)templateDescription;
- (void)setLandscapePrinting:(BOOL)landscape;

//Sent by the tempaltes webview notification done loading and the regular prints right away
- (void)runPrintOperation:(NSNotification *)notification;


@end
